import numpy as np
from scipy.linalg import solve_triangular
from matern_52 import matern_52
from scipy.linalg import cholesky
from numpy.random import standard_normal

def gp_pred_land(y1,L1,Q_x2,Q_x1_x2,delta):
    L1_div_y1 = solve_triangular(L1,y1.T,lower=True)
    Q_div_y1 = solve_triangular(L1.T,L1_div_y1)
    y2_mu = Q_x1_x2.T @ Q_div_y1
    v_pred = solve_triangular(L1,Q_x1_x2,lower=True)
    cov_y2 = Q_x2 - v_pred.T @ v_pred + np.identity(Q_x2.shape[0])*delta
    y2 = y2_mu + cholesky(cov_y2,lower=True) @ standard_normal(y2_mu.shape)
    return y2.T
