import numpy as np
from scipy.io import savemat
    
def save_estimates(fit,modelData,pathOut,fileName):
    
    pars = ['s_small','b_small','s_small_a','b_small_a','pc','s_pc','sy_tg','sy_alti','interc','b','bi','b_ar1','bi_ar1','br','br0','bri','bg','bg0','bgi','b_giar','b_giag',\
            's0','l0','s_ar1','s0_ar1','l_ar1','l0_ar1','rho','h_rel','h_geo','b_uniform','b0_uniform','l_copy','s_copy','s_uniform']
            
    data = {}
    data["lon"] = modelData["lon_tg"]
    data["lat"] = modelData["lat_tg"]
    data["lona"] = modelData["lona"]
    data["lata"] = modelData["lata"]
    data["eof"] =  modelData["eof"]
    data["eofa"] = modelData["eofa"]
    data["M"] = modelData["M"]
    data["K"] = modelData["K"]
    data["mu_giar"] = modelData["mu_giar"]
    data["mu_giag"] = modelData["mu_giag"]
    data["mur"] = modelData["mur"]
    data["mug"] = modelData["mug"]
    
    n = modelData["ntg"] + modelData["na"]
    ntg = modelData["ntg"]
    nt = modelData["nt"]
    na = modelData["na"]
    nta = modelData["nta"]
    K = modelData["K"]
    y = np.zeros((ntg*nt,))*np.NaN
    y[modelData["kok"]-1] = modelData["y_tg"]
    y = np.reshape(y,(nt,ntg),order='C')
    data["sea_level"] = y
    data["sla"] = modelData["ya"]
    
    for par in pars:
        try:
            q = fit.stan_variable(par)
        except:
            continue
        q = np.asarray(q)
        data[par] = q
    savemat(pathOut + fileName,data,oned_as='column')


